<?php
/**
 * Solar Energy Engine functions and definitions
 * @package Solar Energy Engine
 */

if ( ! function_exists( 'solar_energy_engine_after_theme_support' ) ) :

	function solar_energy_engine_after_theme_support() {
		
		add_theme_support( 'automatic-feed-links' );

		add_theme_support('woocommerce');
        add_theme_support('wc-product-gallery-zoom');
        add_theme_support('wc-product-gallery-lightbox');
        add_theme_support('wc-product-gallery-slider');
        add_theme_support('woocommerce', array(
            'gallery_thumbnail_image_width' => 300,
        ));


		add_theme_support(
			'custom-background',
			array(
				'default-color' => 'ffffff',
			)
		);

        load_theme_textdomain( 'solar-energy-engine', get_template_directory() . '/languages' );

		$GLOBALS['content_width'] = apply_filters( 'solar_energy_engine_content_width', 1140 );
		
		add_theme_support( 'post-thumbnails' );

		add_theme_support(
			'custom-logo',
			array(
				'height'      => 270,
				'width'       => 90,
				'flex-height' => true,
				'flex-width'  => true,
			)
		);
		
		add_theme_support( 'title-tag' );

		add_theme_support(
			'html5',
			array(
				'search-form',
				'comment-form',
				'comment-list',
				'gallery',
				'caption',
				'script',
				'style',
			)
		);

		add_theme_support( 'post-formats', array(
			'video',  
			'audio',  
			'gallery',
			'quote',  
			'image',  
			'link',   
			'status', 
			'aside',  
			'chat',   
		) );
		
		add_theme_support( 'align-wide' );
		add_theme_support( 'responsive-embeds' );
		add_theme_support( 'wp-block-styles' );

		add_editor_style('/lib/custom/css/editor-style.css');

		require get_template_directory() . '/inc/metabox.php';
		require get_template_directory() . '/inc/homepage-setup/homepage-setup-settings.php';


		if (! defined( 'SOLAR_ENERGY_ENGINE_DOCS_PRO' ) ){
		define('SOLAR_ENERGY_ENGINE_DOCS_PRO',__('https://layout.omegathemes.com/steps/solar-energy-engine/','solar-energy-engine'));
		}
		if (! defined( 'SOLAR_ENERGY_ENGINE_BUY_NOW' ) ){
		define('SOLAR_ENERGY_ENGINE_BUY_NOW',__('https://www.omegathemes.com/products/solar-energy-wordpress-theme','solar-energy-engine'));
		}
		if (! defined( 'SOLAR_ENERGY_ENGINE_SUPPORT_FREE' ) ){
		define('SOLAR_ENERGY_ENGINE_SUPPORT_FREE',__('https://wordpress.org/support/theme/solar-energy-engine/','solar-energy-engine'));
		}
		if (! defined( 'SOLAR_ENERGY_ENGINE_REVIEW_FREE' ) ){
		define('SOLAR_ENERGY_ENGINE_REVIEW_FREE',__('https://wordpress.org/support/theme/solar-energy-engine/reviews/#new-post','solar-energy-engine'));
		}
		if (! defined( 'SOLAR_ENERGY_ENGINE_DEMO_PRO' ) ){
		define('SOLAR_ENERGY_ENGINE_DEMO_PRO',__('https://layout.omegathemes.com/solar-energy-engine/','solar-energy-engine'));
		}
		if (! defined( 'SOLAR_ENERGY_ENGINE_LITE_DOCS_PRO' ) ){
		define('SOLAR_ENERGY_ENGINE_LITE_DOCS_PRO',__('https://layout.omegathemes.com/steps/free-solar-energy-engine/','solar-energy-engine'));
		}
		if (! defined( 'SOLAR_ENERGY_ENGINE_BUNDLE_BUTTON' ) ){
			define('SOLAR_ENERGY_ENGINE_BUNDLE_BUTTON',__('https://www.omegathemes.com/products/wp-theme-bundle','solar-energy-engine'));
		}

	}

endif;

add_action( 'after_setup_theme', 'solar_energy_engine_after_theme_support' );

/**
 * Register and Enqueue Styles.
 */
function solar_energy_engine_register_styles() {

	wp_enqueue_style( 'dashicons' );

    $solar_energy_engine_theme_version = wp_get_theme()->get( 'Version' );
	$solar_energy_engine_fonts_url = solar_energy_engine_fonts_url();
    if( $solar_energy_engine_fonts_url ){
    	require_once get_theme_file_path( 'lib/custom/css/wptt-webfont-loader.php' );
        wp_enqueue_style(
			'solar-energy-engine-google-fonts',
			solar_energy_engine_wptt_get_webfont_url( $solar_energy_engine_fonts_url ),
			array(),
			$solar_energy_engine_theme_version
		);
    }

    wp_enqueue_style( 'swiper', get_template_directory_uri() . '/lib/swiper/css/swiper-bundle.min.css');
	wp_enqueue_style( 'solar-energy-engine-style', get_stylesheet_uri(), array(), $solar_energy_engine_theme_version );

	wp_enqueue_style( 'solar-energy-engine-style', get_stylesheet_uri() );
	require get_parent_theme_file_path( '/custom_css.php' );
	wp_add_inline_style( 'solar-energy-engine-style',$solar_energy_engine_custom_css );


	$solar_energy_engine_css = '';

	if ( get_header_image() ) :

		$solar_energy_engine_css .=  '
			.header-navbar{
				background-image: url('.esc_url(get_header_image()).');
				-webkit-background-size: cover !important;
				-moz-background-size: cover !important;
				-o-background-size: cover !important;
				background-size: cover !important;
			}';

	endif;

	wp_add_inline_style( 'solar-energy-engine-style', $solar_energy_engine_css );


	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}	

	wp_enqueue_script( 'imagesloaded' );
    wp_enqueue_script( 'masonry' );
	wp_enqueue_script( 'swiper', get_template_directory_uri() . '/lib/swiper/js/swiper-bundle.min.js', array('jquery'), '', 1);
	wp_enqueue_script( 'solar-energy-engine-custom', get_template_directory_uri() . '/lib/custom/js/theme-custom-script.js', array('jquery'), '', 1);

    // Global Query
    if( is_front_page() ){

    	$solar_energy_engine_posts_per_page = absint( get_option('posts_per_page') );
        $solar_energy_engine_c_paged = ( get_query_var( 'page' ) ) ? absint( get_query_var( 'page' ) ) : 1;
        $solar_energy_engine_posts_args = array(
            'posts_per_page'        => $solar_energy_engine_posts_per_page,
            'paged'                 => $solar_energy_engine_c_paged,
        );
        $solar_energy_engine_posts_qry = new WP_Query( $solar_energy_engine_posts_args );
        $max = $solar_energy_engine_posts_qry->max_num_pages;

    }else{
        global $wp_query;
        $max = $wp_query->max_num_pages;
        $solar_energy_engine_c_paged = ( get_query_var( 'paged' ) > 1 ) ? get_query_var( 'paged' ) : 1;
    }

    $solar_energy_engine_default = solar_energy_engine_get_default_theme_options();
    $solar_energy_engine_pagination_layout = get_theme_mod( 'solar_energy_engine_pagination_layout',$solar_energy_engine_default['solar_energy_engine_pagination_layout'] );
}

add_action( 'wp_enqueue_scripts', 'solar_energy_engine_register_styles',200 );

function solar_energy_engine_admin_enqueue_scripts_callback() {
    if ( ! did_action( 'wp_enqueue_media' ) ) {
    wp_enqueue_media();
    }
    wp_enqueue_script('solar-energy-engine-uploaderjs', get_stylesheet_directory_uri() . '/lib/custom/js/uploader.js', array(), "1.0", true);
}
add_action( 'admin_enqueue_scripts', 'solar_energy_engine_admin_enqueue_scripts_callback' );

/**
 * Register navigation menus uses wp_nav_menu in five places.
 */
function solar_energy_engine_menus() {

	$solar_energy_engine_locations = array(
		'solar-energy-engine-primary-menu'  => esc_html__( 'Primary Menu', 'solar-energy-engine' ),
	);

	register_nav_menus( $solar_energy_engine_locations );
}

add_action( 'init', 'solar_energy_engine_menus' );


add_filter('loop_shop_columns', 'solar_energy_engine_loop_columns');
if (!function_exists('solar_energy_engine_loop_columns')) {
	function solar_energy_engine_loop_columns() {
		$solar_energy_engine_columns = get_theme_mod( 'solar_energy_engine_per_columns', 3 );
		return $solar_energy_engine_columns;
	}
}

add_filter( 'loop_shop_per_page', 'solar_energy_engine_per_page', 20 );
function solar_energy_engine_per_page( $solar_energy_engine_cols ) {
  	$solar_energy_engine_cols = get_theme_mod( 'solar_energy_engine_product_per_page', 9 );
	return $solar_energy_engine_cols;
}

add_filter( 'woocommerce_output_related_products_args', 'solar_energy_engine_products_args' );

function solar_energy_engine_products_args( $solar_energy_engine_args ) {

    $solar_energy_engine_args['posts_per_page'] = get_theme_mod( 'solar_energy_engine_custom_related_products_number', 6 );

    $solar_energy_engine_args['columns'] = get_theme_mod( 'solar_energy_engine_custom_related_products_number_per_row', 3 );

    return $solar_energy_engine_args;
}

require get_template_directory() . '/inc/custom-header.php';
require get_template_directory() . '/classes/class-svg-icons.php';
require get_template_directory() . '/classes/class-walker-menu.php';
require get_template_directory() . '/inc/customizer/customizer.php';
require get_template_directory() . '/inc/custom-functions.php';
require get_template_directory() . '/inc/template-tags.php';
require get_template_directory() . '/classes/body-classes.php';
require get_template_directory() . '/inc/widgets/widgets.php';
require get_template_directory() . '/inc/pagination.php';
require get_template_directory() . '/lib/breadcrumbs/breadcrumbs.php';
require get_template_directory() . '/lib/custom/css/dynamic-style.php';


function solar_energy_engine_remove_customize_register() {
    global $wp_customize;

    $wp_customize->remove_setting( 'display_header_text' );
    $wp_customize->remove_control( 'display_header_text' );

}

add_action( 'customize_register', 'solar_energy_engine_remove_customize_register', 11 );

// Apply styles based on customizer settings

function solar_energy_engine_radio_sanitize(  $solar_energy_engine_input, $solar_energy_engine_setting  ) {
	$solar_energy_engine_input = sanitize_key( $solar_energy_engine_input );
	$solar_energy_engine_choices = $solar_energy_engine_setting->manager->get_control( $solar_energy_engine_setting->id )->choices;
	return ( array_key_exists( $solar_energy_engine_input, $solar_energy_engine_choices ) ? $solar_energy_engine_input : $solar_energy_engine_setting->default );
}
require get_template_directory() . '/inc/general.php';

function solar_energy_engine_sticky_sidebar_enabled() {
    $solar_energy_engine_sticky_sidebar = get_theme_mod('solar_energy_engine_sticky_sidebar', true);
    
    if ($solar_energy_engine_sticky_sidebar == false) {
        $solar_energy_engine_custom_css = ".widget-area-wrapper { position: relative !important; }";
        wp_add_inline_style('solar-energy-engine-style', $solar_energy_engine_custom_css);
    }
}
add_action('wp_enqueue_scripts', 'solar_energy_engine_sticky_sidebar_enabled');

// NOTICE FUNCTION

function solar_energy_engine_admin_notice() { 
    global $pagenow;
    $theme_args = wp_get_theme();
    $meta = get_option( 'solar_energy_engine_admin_notice' );
    $name = $theme_args->get( 'Name' );
    $current_screen = get_current_screen();

    if ( ! $meta ) {
        if ( is_network_admin() ) {
            return;
        }

        if ( ! current_user_can( 'manage_options' ) ) {
            return;
        }

        if ( $current_screen->base != 'appearance_page_solarenergyengine-wizard' ) {
            ?>
            <div class="notice notice-success notice-content">
                <h2><?php esc_html_e('Welcome! Thank you for choosing Solar Energy Engine. Let’s Set Up Your Website!', 'solar-energy-engine') ?> </h2>
                <p><?php esc_html_e('Before you dive into customization, let’s go through a quick setup process to ensure everything runs smoothly. Click below to start setting up your website in minutes!', 'solar-energy-engine') ?> </p>
                <div class="info-link">
                    <a href="<?php echo esc_url( admin_url( 'themes.php?page=solarenergyengine-wizard' ) ); ?>"><?php esc_html_e('Get Started with Solar Energy Engine', 'solar-energy-engine'); ?></a>
                </div>
                <p class="dismiss-link"><strong><a href="?solar_energy_engine_admin_notice=1"><?php esc_html_e( 'Dismiss', 'solar-energy-engine' ); ?></a></strong></p>
            </div>
            <?php
        }
    }
}
add_action( 'admin_notices', 'solar_energy_engine_admin_notice' );

if ( ! function_exists( 'solar_energy_engine_update_admin_notice' ) ) :
/**
 * Updating admin notice on dismiss
 */
function solar_energy_engine_update_admin_notice() {
    if ( isset( $_GET['solar_energy_engine_admin_notice'] ) && $_GET['solar_energy_engine_admin_notice'] == '1' ) {
        update_option( 'solar_energy_engine_admin_notice', true );
    }
}
endif;
add_action( 'admin_init', 'solar_energy_engine_update_admin_notice' );

// After Switch theme function
add_action( 'after_switch_theme', 'solar_energy_engine_getstart_setup_options' );
function solar_energy_engine_getstart_setup_options() {
    update_option( 'solar_energy_engine_admin_notice', false );
}